#!/usr/bin/python
# ukázka připojení klávesnice 4x1 a obsluha 1 výstupu na expanderu PCF8574
# Společný pin klávesnice je připojen na zem, stisk tlačítka dá stav 0.
 
import smbus
import time

def get_pin_pcf8574_2(x):   # cteni stavu jednotlivych bitu
    data = bus.read_byte(pcf8574_2)
    if (data & (2 ** x)) == 0:
        return False
    else :
        return True

def set_pin_pcf8574_2(pcf8574_2, pin_num, low_high):
    # nastaveni stavu jednotlivych bitu
    data = bus.read_byte(pcf8574_2)
    
    if pin_num == 0: hodnota = 0x01
    elif pin_num == 1: hodnota = 0x02
    elif pin_num == 2: hodnota = 0x04
    elif pin_num == 3: hodnota = 0x08
    elif pin_num == 4: hodnota = 0x10
    elif pin_num == 5: hodnota = 0x20
    elif pin_num == 6: hodnota = 0x40
    elif pin_num == 7: hodnota = 0x80
    else:
        print("Neexistující pin na PCF8574 ", pcf8574_2)
        return
    
    if low_high == 0:
        data = data ^ hodnota
    else:
        data = data | hodnota
    
    bus.write_byte(pcf8574_2, data)
    
# START programu
bus = smbus.SMBus(1)    # SMBus(0) pro starsi verze Pi

pcf8574_2 = 0x21   # adresa 2. modulu PCF8574 - nastaveno jumperem
                  
#bus.write_byte(pcf8574_2, 0xff)  # 0xFF(255) vsechny piny nastaveny jako vstupni

# piny klavesnice 4x1   
pin_sviti = 7    # předposlední pin na konektoru, poslední pin neni pouzit
pin_nesviti = 6
pin_konec = 5      
pin_sirena = 4

vystup_1 = 0  # první pin na konektoru (u jumperu)

# Nestisknuté tlačítko není nikam připojeno a neni jisté,
# jak bude expanderem vyhodnocen jeho stav (0 nebo 1?).
# Společný pin klávesnice je připojen na zem, stisk tlačítka dá stav 0.
set_pin_pcf8574_2(pcf8574_2, pin_sirena, 1)   # klidový stav tlačítek je 1
set_pin_pcf8574_2(pcf8574_2, pin_sviti, 1)
set_pin_pcf8574_2(pcf8574_2, pin_nesviti, 1)
set_pin_pcf8574_2(pcf8574_2, pin_konec, 1) 

print("mačkej tlačítka")

while True:  
    if get_pin_pcf8574_2(pin_sirena) == 0:  # bylo stisknuto tlačítko "sirena"  
        time.sleep(0.2)  # pro potlaceni zakmitu tlacitka
        set_pin_pcf8574_2(pcf8574_2, pin_sirena, 1)   # klidový stav tlačítka je 1
        print("siréna")
                               
    if get_pin_pcf8574_2(pin_sviti) == 0:
        time.sleep(0.2)  
        set_pin_pcf8574_2(pcf8574_2, pin_sviti, 1) 
        print("svítí")
        # nastav vystup_1 na 1
        set_pin_pcf8574_2(pcf8574_2, vystup_1, True)   # True nebo 1
                
    if get_pin_pcf8574_2(pin_nesviti) == 0:
        time.sleep(0.2)  
        set_pin_pcf8574_2(pcf8574_2, pin_nesviti, 1) 
        print("nesvítí")
        # nastav vystup_1 na 0
        set_pin_pcf8574_2(pcf8574_2, vystup_1, False)  # False nebo 0
        #time.sleep(2) 
        
    if get_pin_pcf8574_2(pin_konec) == 0: # 
        time.sleep(0.2)  
        print("konec programu")
        exit()
        
     
     